package BackUp;
require CMONOS::CGI_Lib::SetUp;
@ISA = qw(SetUp);
use strict;
use utf8;
######################################################################
# バックアップモジュール
# BackUp.pm ver1.1.5
# Copyright (C) 1999-2015 CMONOS Co. Ltd.
# 
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2016-01-04
######################################################################
# 実行
sub run ($) {
my $this = shift;
push(@main::db,$main::db) if defined $main::db && $main::db ne '';
@main::db = grep(defined $_ && $_ ne '',@main::db);
undef $main::db;
$main::a = '' if !defined $main::a;
if (@main::db) {
	use Fcntl qw(:DEFAULT :flock);
	eval 'use ' . $env::dbm_file . ';';

	#データベース・設定 のバックアップ
	if ($main::a eq 'backup') {
		my($db);
		foreach $db (@main::db) {
			if ($db eq 'deco') {
				if (defined $default::subdivided && defined $main::c && $default::subdivided && $main::c ne '') {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップは作成できません。');
				} elsif ($this->backup_db($env::preference_dir . '/deco')) {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップを作成しました。');
				} else {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップ作成に失敗しました。');
				}
			} elsif ($db eq 'table') {
				if ($default::subdivided && defined $main::c && $main::c ne '') {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップは作成できません。');
				} elsif ($this->backup_db($env::preference_dir . '/table')) {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップを作成しました。');
				} else {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップ作成に失敗しました。');
				}
			} elsif ($db eq 'pref') {
				if ($this->backup_dir($default::preference_dir)) {
					push(@{$this->{'dialog'}},'初期設定のバックアップを作成しました。');
				} else {
					push(@{$this->{'dialog'}},'初期設定のバックアップ作成に失敗しました。');
				}
			} elsif ($db eq 'field') {
				if ($default::subdivided && (!defined $main::c || $main::c eq '')) {
					push(@{$this->{'dialog'}},'フィールド設定のバックアップは作成できません。');
				} elsif ($this->backup_dir($default::field_pref_dir)) {
					push(@{$this->{'dialog'}},'フィールド設定のバックアップを作成しました。');
				} else {
					push(@{$this->{'dialog'}},'フィールド設定のバックアップ作成に失敗しました。');
				}
			} elsif (defined $backup::db_path{$db} && $backup::db_path{$db} ne '' && -d $backup::db_path{$db}) {
				if ($this->backup_dir($backup::db_path{$db},$backup::find{$db})) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップを作成しました。');
				} else {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'バックアップ作成に失敗しました。');
				}
			} elsif (defined $backup::db_path{$db} && $backup::db_path{$db} ne '') {
				if ($this->backup_db($backup::db_path{$db})) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップを作成しました。');
				} else {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップ作成に失敗しました。');
				}
			}
		}

	#バックアップの削除
	} elsif ($main::a eq 'delete') {
		my($db);
		foreach $db (@main::db) {
			if ($db eq 'deco') {
				if (defined $default::subdivided && defined $main::c && $default::subdivided && $main::c ne '') {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップは削除できません。');
				} elsif (unlink $env::preference_dir . '/deco.bak') {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップを削除しました。');
				} elsif (-f $env::preference_dir . '/deco.bak') {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップ削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'画像設定（共通）のバックアップは存在しません。');
				}
			} elsif ($db eq 'table') {
				if (defined $default::subdivided && defined $main::c && $default::subdivided && $main::c ne '') {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップは削除できません。');
				} elsif (unlink $env::preference_dir . '/table.bak') {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップを削除しました。');
				} elsif (-f $env::preference_dir . '/table.bak') {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップ削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップは存在しません。');
				}
			} elsif ($db eq 'pref') {
				my @unlink = $this->fileglob($default::preference_dir,'\.bak$','f');
				if (unlink @unlink) {
					push(@{$this->{'dialog'}},'初期設定のバックアップを削除しました。');
				} elsif (@unlink) {
					push(@{$this->{'dialog'}},'初期設定のバックアップ削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'初期設定のバックアップは存在しません。');
				}
			} elsif ($db eq 'field') {
				my @unlink = $this->fileglob($default::field_pref_dir,'\.bak$','f');
				if (defined $default::subdivided && $default::subdivided && (!defined $main::c || $main::c eq '')) {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のバックアップは削除できません。');
				} elsif (unlink @unlink) {
					push(@{$this->{'dialog'}},'フィールド設定のバックアップを削除しました。');
				} elsif (@unlink) {
					push(@{$this->{'dialog'}},'フィールド設定のバックアップ削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'フィールド設定のバックアップは存在しません。');
				}
			} elsif (defined $backup::db_path{$db} && $backup::db_path{$db} ne '' && -d $backup::db_path{$db}) {
				my @unlink = $this->fileglob($backup::db_path{$db},'\.bak$','f',$backup::find{$db},0,'^[\-\.]');
				if (unlink @unlink) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップを削除しました。');
				} elsif (@unlink) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップ削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップは存在しません。');
				}
			} elsif (defined $backup::db_path{$db} && $backup::db_path{$db} ne '') {
				if (unlink $backup::db_path{$db} . '.bak') {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップを削除しました。');
				} elsif (-f $backup::db_path{$db} . '.bak') {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップ削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のバックアップは存在しません。');
				}
			}
		}

	#データベースの削除
	} elsif ($this->is_master && $main::a eq 'dbdelete') {
		my($db,$pat);
		$pat = '^[0-9a-zA-Z_]{1,20}(\.db|\.dir|\.pag|)$';
		foreach $db (@main::db) {
			if ($db eq 'deco') {
				if (defined $default::subdivided && defined $main::c && $default::subdivided && $main::c ne '') {
					push(@{$this->{'dialog'}},'画像設定（共通）のデータベースは削除できません。');
				} elsif (unlink($env::preference_dir . '/deco',$env::preference_dir . '/deco.db',$env::preference_dir . '/deco.dir',$env::preference_dir . '/deco.pag')) {
					push(@{$this->{'dialog'}},'画像設定（共通）のデータベースを削除しました。');
				} elsif (-e $env::preference_dir . '/deco' || -e $env::preference_dir . '/deco.db' || (-e $env::preference_dir . '/deco.dir' && -e $env::preference_dir . '/deco.pag')) {
					push(@{$this->{'dialog'}},'画像設定（共通）のデータベース削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'画像設定（共通）のデータベースは存在しません。');
				}
			} elsif ($db eq 'table') {
				if (defined $default::subdivided && defined $main::c && $default::subdivided && $main::c ne '') {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のデータベースは削除できません。');
				} elsif (unlink($env::preference_dir . '/table',$env::preference_dir . '/table.db',$env::preference_dir . '/table.dir',$env::preference_dir . '/table.pag')) {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のデータベースを削除しました。');
				} elsif (-e $env::preference_dir . '/table' || -e $env::preference_dir . '/table.db' || (-e $env::preference_dir . '/table.dir' && -e $env::preference_dir . '/table.pag')) {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のデータベース削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のデータベースは存在しません。');
				}
			} elsif ($db eq 'pref') {
				my @unlink = $this->fileglob($default::preference_dir,$pat,'f');
				if (unlink @unlink) {
					push(@{$this->{'dialog'}},'初期設定のデータベースを削除しました。');
				} elsif (@unlink) {
					push(@{$this->{'dialog'}},'初期設定のデータベース削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'初期設定のデータベースは存在しません。');
				}
			} elsif ($db eq 'field') {
				my @unlink = $this->fileglob($default::field_pref_dir,$pat,'f');
				if (defined $default::subdivided && $default::subdivided && (!defined $main::c || $main::c eq '')) {
					push(@{$this->{'dialog'}},'テーブル設定（共通）のデータベースは削除できません。');
				} elsif (unlink @unlink) {
					push(@{$this->{'dialog'}},'フィールド設定のデータベースを削除しました。');
				} elsif (@unlink) {
					push(@{$this->{'dialog'}},'フィールド設定のデータベース削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},'フィールド設定のデータベースは存在しません。');
				}
			} elsif (defined $backup::db_path{$db} && $backup::db_path{$db} ne '' && -d $backup::db_path{$db}) {
				my @unlink = $this->fileglob($backup::db_path{$db},$pat,'f',$backup::find{$db},0,'[^0-9a-zA-Z_]');
				if (unlink @unlink) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のデータベースを削除しました。');
				} elsif (@unlink) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のデータベース削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のデータベースは存在しません。');
				}
			} elsif (defined $backup::db_path{$db} && $backup::db_path{$db} ne '') {
				if (unlink($backup::db_path{$db},$backup::db_path{$db} . '.db',$backup::db_path{$db} . '.dir',$backup::db_path{$db} . '.pag')) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のデータベースを削除しました。');
				} elsif (-e $backup::db_path{$db} || -e $backup::db_path{$db} . '.db' || (-e $backup::db_path{$db} . '.dir' && -e $backup::db_path{$db} . '.pag')) {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のデータベース削除に失敗しました。');
				} else {
					push(@{$this->{'dialog'}},$backup::db_name{$db} . 'のデータベースは存在しません。');
				}
			}
		}
	}

} elsif ($main::a ne '') {
	push(@{$this->{'dialog'}},'処理対象が指定されていません。');

}

#ページヘッダ
$this->jump_menu('tools','backup');
$this->print_page_header('tools');

print '<h1>データベース・設定 のバックアップ</h1>';

print $this->form_start(
	'key'	=>	'tools',
	'name'	=>	'input',
	'method'	=>	'post',
	'required'	=>	\@setting::form
);

print '<fieldset><table class="field-table"><tbody><tr><td class="field-name"><label for="db">対象</label></td>';

print '<td class="field"><select name="db" id="db" multiple="multiple">';
if ($env::preference_dir && (!$default::subdivided || !defined $main::c || $main::c eq '')) {
	print '<option value="deco">画像設定（共通）</option>' if $setting::deco;
	print '<option value="table">テーブル設定（共通）</option>' if $setting::table;
}
print '<option value="pref">初期設定</option>' if defined $default::preference_dir && $default::preference_dir;
print '<option value="field">フィールド設定</option>' if defined $default::field_pref_dir && $default::field_pref_dir && (!$default::subdivided || (defined $main::c && $main::c ne ''));

if (%backup::db_name) {
	foreach (sort keys %backup::db_name) {
		print '<option value="', $_, '">', $backup::db_name{$_}, '</option>';
	}
}

print '</select>';

print '</td></tr>';

print '<tr><td class="field-name"><label for="a">処理</label></td>';
print '<td class="field"><select name="a" id="a">';
print '<option value="backup">バックアップ作成</option>';
print '<option value="delete">バックアップ削除</option>';
if ($this->is_master) {
	print '<option value=""></option>';
	print '<option value="dbdelete">データベース削除</option>';
}
print '</select>';
print '</td></tr>';

print '</tbody></table></fieldset>';

print '<fieldset class="submit"><input type="submit" value="実行" class="save" /></fieldset></form>';

#ページフッタ
$this->print_page_footer('tools');

}

######################################################################
# ディレクトリ内のDBをバックアップ
sub backup_dir ($$;$) {
my($this,$path,$find) = @_;
my(@files,$db,%db,$check);
$path =~ s!/$!!;
$check = 0;

return unless opendir(DIR,$path);
@files = readdir(DIR);
closedir(DIR);

foreach $db (@files) {
	next if $db =~ /^\./ || $db =~ /\.(bak|default|txt|html|htm|gif|jpg|png)$/i;
	if (-d $path . '/' . $db) {
		next if !defined $find || !$find;
		$check = 1 if $this->backup_dir($path . '/' . $db,$find);
	} elsif (-f $path . '/' . $db) {
		$db =~ s/\.[^\/\.]+$//;
		$db{$db} = 1;
	}
}
foreach $db (keys %db) {
	$check = 1 if $this->backup_db($path . '/' . $db);
}
return $check;
}

######################################################################
# DBをバックアップ
sub backup_db ($$) {
my($this,$path) = @_;
return if $path =~ /\.(bak|default|txt|html|htm|gif|jpg|png)$/i;
my(%db_hash,$done);
my $home_dir_id = ($env::home_dir_id) ? $env::home_dir_id : '';
my $user_directory = $this->home_directory(1);
my $home_url = $this->full_path('../../',1);
my $home_url_encoded = $this->url_encode($home_url);
$done = 0;
$path =~ s/\.[^\/\.]+$//;
tie(%db_hash, $env::dbm_file, $path, O_RDONLY, $env::dbm_mode);
if (ref tied %db_hash) {
	$path .= '.bak';
	local(*BAK);
	if (open(BAK, ">>$path")) {
		binmode BAK, ":utf8";
		flock(BAK, LOCK_EX);
		truncate(BAK, 0);
		seek(BAK, 0, 0);
		my($k,$v);
		while (eval{($k,$v) = each %db_hash}) {
			utf8::decode($k) if !utf8::is_utf8($k);
			utf8::decode($v) if !utf8::is_utf8($v);
			if (defined $k && $k ne '') {
				$v = '' if !defined $v;
				$k =~ s/\x09/&#09;/gs;
				$k =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
				$k =~ s/[\x00-\x0A\x0C-\x1F\x7F]+//gs;
				$v =~ s!($user_directory|\.)(/lib/(?:xfiles|javascript|css)/)!(($1 && $1 eq '.') ? $1 . $2 : '<user-directory>' . $2)!ge;
				if ($home_dir_id) {
					$v =~ s!\Q$user_directory\E(?=["'/])!<user-directory>!gs;
					$v =~ s/#document_$home_dir_id/#document_<home-dir-id>/g;
				} else {
					$v =~ s/([\x09\x0A\x0C\x0D\x20]+(?:src|href|background|virtual|action)=(?:&quot;|["'])(?!\/\/))\Q$user_directory\E(?=(?:[\/"']|&quot;))/$1<user-directory>/gi;
					$v =~ s/#document_(?!_)/#document_<home-dir-id>/g;
				}
				$v =~ s!$home_url!<home-url>!g;
				$v =~ s/$home_url_encoded/<home-url-encoded>/g;
				$v =~ s/\x09/&#09;/gs;
				$v =~ s/(\x0D\x0A|\x0D|\x0A)/\x0B/gs;
				$v =~ s/[\x00-\x0A\x0C-\x1F\x7F]+//gs;
				print BAK $k;
				print BAK "\x09";
				print BAK $v;
				print BAK "\x0A";
			}
			undef $k;
			undef $v;
		}
		close (BAK);
		$done = 1;
	}
}
untie %db_hash;
chmod($env::file_mode, $path);
return $done;
}

######################################################################
# クラス登録
#sub import {
BEGIN {
	#クラス登録
	Common::class_register('xxbb','BackUp');

	#メニュー登録
	$setting::jump_menu{'xxbb'} = 'データベース・設定 のバックアップ';
}


1;
